///home/berryj/link/bin/genMethods "-g" "-t" "Graph*" "-h" "MSet" "-r" "Collection<Graph*>" "-I" "LINK/basic/MSet.h" "-I" "LINK/graph/Graph.h" "-d" "graph" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/basic/MSet.h>

#include <LINK/graph/Graph.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>
#include <LINK/stkWrapper/CollectionWrapper.h>


typedef Graph* _Graph_;
typedef MSet<Graph* > _MSet_Graph__;
static MSet<Graph* > s__MSet_Graph__;

#define _MSet_Graph__DATA(x) ((MSet<Graph* >*) (EXTDATA(x)))
#define _MSet_Graph__IS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<MSet<Graph* > >::type))
#define _MSet_Graph__ISNT_DATA(x) (!_MSet_Graph__IS_DATA(x))

#define _MSet_Graph__CXX_DATA(x) (*(MSet<Graph* >*) (EXTDATA(VAL(x))))
#define _MSet_Graph__CXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<MSet<Graph* > >::type))
#define _MSet_Graph__CXX_ISNT_DATA(x) (!_MSet_Graph__CXX_IS_DATA(x))


PRIMITIVE STk_init__MSet_Graph__()
{
	Wrapper<_MSet_Graph__>::type = STk_new_CXXwrapper_id(
			Wrapper<_MSet_Graph__>::name, 
			Wrapper<Collection<Graph*> >::name,
			(void (*)(SCM x, SCM port, int mode))
			CollectionWrapper<_Graph_>::displayTypedCollection,
			(void (*)(SCM x))CollectionWrapper<_Graph_>::markTypedCollection,
			(void (*)(SCM x))CollectionWrapper<_Graph_>::freeTypedCollection);
	Tcl_InitHashTable(&Register<_MSet_Graph__>::objTable, TCL_ONE_WORD_KEYS);
	return UNDEFINED;
}

void genExtra_MSet_Graph__Methods(void);

PRIMITIVE STk_init_methods__MSet_Graph__()
{
	genExtra_MSet_Graph__Methods();
	return UNDEFINED;
}
